debug(false);

Plugins.load( "UIKit" );
Plugins.load( "FileManager" );

include("scripts/server.js");
include("scripts/base64.js");
include("scripts/settings.js");
include("scripts/buttonbar.js");
include("scripts/dialogs.js");
include("scripts/fileprops.js");
include("scripts/textedit.js");
include("scripts/associations.js");

var folderImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_folder.png");
var fileImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_file.png");
var iconImage= new UIImageView(Images.imageWithContentsOfFile(Bundle.bundlePath+"/images/logo.png", false));

var excelImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_excel.png");
var mp3Image= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_sound.png");
var pdfImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_pdf.png");
var wordImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_word.png");
var imageImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_image.png");
var htmlImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_html.png");
var archiveImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_archive.png");
var videoImage= Images.imageAtPath(Bundle.bundlePath+"/images/32x32_video.png");


var window = new
 UIWindow( UIHardware.fullScreenApplicationContentRect );

window.setHidden( false );
window.orderFront();
window.makeKey();
window.backgroundColor=[1 , 1 , 1 , 1];

var mainView = new UITransitionView( window.bounds );
var currentView = null;
var currentPath;
var webView;
var rotated = false;
var url;
var xyz = [0,0,0];
var clipboard = [];
var deleteAfterPaste = false;
var searchMode = false;
var textEditing = false;
var sendEmail = false;

var raDefault = Defaults.get("restrictAccess");
var ufDefault = Defaults.get("useFile");
var unDefault = Defaults.get("username");
var pwDefault = Defaults.get("password");
var hdDefault = Defaults.get("homeDir");
var ihDefault = Defaults.get("includeHidden");
var lastPath = Defaults.get("lastPath");

if (Defaults.get("associations")==null) {
 initAssociations();
}

var restrictAccess = (raDefault!="0");
var useFile = (ufDefault=="1");
var includeHidden = (ihDefault=="1");
var username = (unDefault!=null)?unDefault:"filebrowser";
var password = (pwDefault!=null)?pwDefault:randomString();
var homeDir = (hdDefault!=null)?hdDefault:"/var/mobile/";
var viewing = false;
var lastOrientation = -1;
var editMode = false;
var propMode = false;
var selection;


var unzipApp = "/var/root/bin/unzip";
var unrarApp = "/var/root/bin/unrar";


currentPath = homeDir;
if (lastPath!=null && FileManager.directoryExists(lastPath)) currentPath=lastPath;

window.setContentView( mainView );

showContentOf(currentPath, 1);
var serverStr = startServer();



function showContentOf(path, direction) {

  var content = FileManager.directoryContents(path, includeHidden);

  for (var i=0; i<content.length; i++) {
    content[i].dir = path;
  }
  searchMode = false;
  currentPath = path;
  showDirectory(content, direction);

}

function showDirectory(content, direction, searchMode) {

  var dirView = new UIView(mainView.bounds);
  viewing = false;
    
  if (currentView==null) {
    mainView.transition( 0 , dirView );
  }  
  else
    mainView.transitionFrom( direction , currentView , dirView );
 
  currentView = dirView;
  var titleBar = new UINavigationBar( [ 0 , 0 , 320 , 48 ] );
 // titleBar.setBarStyle(1);

  var showPath = currentPath;
  if (showPath.length>20) showPath = "..."+showPath.substring(showPath.length-20,showPath.length-1);
  if (searchMode) showPath = "Search results";
  
  titleBar.pushNavigationItem( new UINavigationItem( showPath) );
  dirView.addSubview( titleBar );

  var table = createTable(content, dirView);

  var bb = new UIButtonBar( mainView , [ 0 , 412 , 320 , 48 ] , buttons );
  bb.registerButtonGroup( 1 , [ 1 , 2 , 3, 4, 5 ] );
  bb.registerButtonGroup( 2 , [ 6 , 8 , 7, 9, 10 ] );
  bb.registerButtonGroup( 3 , [ 6 , 11 , 12, 13, 14] );
  bb.showButtonGroup( 1 , 0 );
  bb.barStyle = 1;
  if (clipboard.length>0)
    bb.setBadgeValue( 3 , clipboard.length );

  if (propMode) bb.showButtonGroup(3, 0);
  
  currentView = dirView;

  bb.onButtonPressed = function( bar , button )
  {
    bb.showSelectionForButton( button );

    if (button==1) folderUp();
    
    if (button==2) {
       createNew();
    }
    
    if (button==3) {
      bb.showButtonGroup( 2 , 0.5 );
      editMode = true;
    }
    
    if (button==4) {
      bb.showButtonGroup( 3 , 0.5 );
    }
        
    if (button==5) {
      var settingsView = createSettingsView( mainView, serverStr );
      mainView.transitionFrom( 3, currentView , settingsView );
    }
    
    if (button==6) {
      bb.showButtonGroup( 1 , 0.5 );
      editMode = false;
      textEditing = false;
      sendEmail = false;
      if (propMode) { propMode = false; showContentOf(currentPath,0);}
    }
    
    // Copy
    if (button==8) {
      deleteAfterPaste = false;
      clipboard = table.getSelectedFiles();
      bb.showButtonGroup( 1 , 0.5 );
      editMode = false;
      showContentOf(currentPath, 0);
    }
    
    // CUT
    if (button==7) {
      deleteAfterPaste = true;
      clipboard = table.getSelectedFiles();
      bb.showButtonGroup( 1 , 0.5 );
      editMode = false;
      showContentOf(currentPath, 0);
    }
    
    // Paste
    if (button==9) {
      paste( dirView );      
      editMode = false;
      bb.setBadgeValue( 3 , null );
    }
    
    // Delete
    if (button==10) { 
      deleteFilesDialog(table.getSelectedFiles());
    }
    
    // Search
    if (button==11) {
      search();
    }
    
    // File properties
    if (button==12) {
      propMode = true;
      textEditing = false;
      sendEmail = false;
      titleBar.popNavigationItem();
      titleBar.popNavigationItem();
      titleBar.pushNavigationItem( new UINavigationItem( "Select File") );
    }
    
    // Text editor
    if (button==13) {
      textEditing = true;
      propMode = false;
      sendEmail = false;
      titleBar.popNavigationItem();
      titleBar.popNavigationItem();
      titleBar.pushNavigationItem( new UINavigationItem( "Select File") );
    }
    
    // Send as attachment
    if (button==14) {
      textEditing = false;
      propMode = false;
      sendEmail = true;
      titleBar.popNavigationItem();
      titleBar.popNavigationItem();
      titleBar.pushNavigationItem( new UINavigationItem( "Select File") );
    }
    
  }
  
    
  table.reloadData(); 
  
  iconImage.position = [2,5];
  iconImage.onTap = function() {
    folderUp();
  }
  
  dirView.addSubview( iconImage );

  titleBar.onTap =   function() 
  { 
    if (editMode) {
      for (var i = 0; i<selection.length; i++) {
        selection[i] = !selection[i];
        table.selectRow(i,selection[i]);
      } 
     } 
      else {
        if (homeDir!=currentPath)
          showContentOf(homeDir, 2);
      }
    }

}



// Create a table
function createTable(content, dirView) {
  var rect = mainView.bounds;
  rect[1]+=48;
  rect[3]-=96;

  var table = new UITable( rect );

  dirView.addSubview( table );

  table.rowHeight = 48;

  var cells = [];
  var fileCells = [];
  selection = [];
  var dir = content;

  if (dir != null) {
    for (i = 0; i < dir.length; i++) {
        // var cell = new UITableCell( [ 0 , 0 , table.bounds[2] , table.rowHeight ] );
        var cell = new UIImageAndTextTableCell();
        //var label = new UITextLabel( cell.bounds );

        cell.title = String( dir[i]["path"]);
        cell.setDisclosureStyle( 1 );
        cell.setSelectionStyle( 4 );
        cell.dir = dir[i].dir;
        
        if (dir[i].type=="d" || dir[i].type=="l") {
          cell.setImage(folderImage);
          
          cell.isDir = true;
          cells.push( cell );
          selection.push(false);
        } else {
          cell.isDir = false;
          setIcon(cell, dir[i].path);
          fileCells.push( cell );
          selection.push( false );
        }
    }
    
    for (i=0; i< fileCells.length; i++) {
      cells.push( fileCells[i] );
    }

  }

table.separatorStyle = 1;
table.addTableColumn( new UITableColumn( "column" , "column" , table.bounds[2] ) );


table.onGetNumberOfRows = function( tbl )
{
  return cells.length;
};

table.onGetCell = function( tbl , col , row )
{
  if (editMode) {
     for (var i = 0; i< selection.length; i++) cells[i].setSelected(selection[i]);
   }

  return cells[ row ];
};

table.onShowDisclosureForRow = function( tbl , row )
{
  return cells[row].showDisclosure = cells[row].isDir;
}

table.onCanSelectRow = function( tbl , row )
{
  return true;
}

table.selectRow = function(row, val) {
  cells[row].setSelected(val);
}

table.onRowSelected = function( tbl , row )
{
  cell = cells[ row ];
  var filename = cell.dir+cell.title;
  
  if (editMode) {
    selection[row] = !selection[row];
    for (var i = 0; i< selection.length; i++) cells[i].setSelected(selection[i]);
    return;
  }
  
  if (propMode) {
    showProps(filename);
    return;
  }
  
  if (textEditing) {
    showTextView(filename);
    textEditing = false;
    return;
  }
  
  if (sendEmail) {
  
    openURL("mailto:?attachment="+encodeURI(filename));
    sendEmail = false;
    return;
  }
  
  if (cell.isDir) {
    showContentOf( cell.dir + cell.title +"/", 1 );
  } else {
    
    var ending = filename.substring(filename.lastIndexOf(".")+1,filename.length).toUpperCase();
    
    // UNZIP
    if (ending=="ZIP") {
       if ( FileManager.fileExists(unzipApp) ) {
         unpack(filename);
       } else showAlert("Unzip", "Please install Unzip from your Installer");
       return;
    }
  
    // UNRAR
    if (ending=="RAR") {
       if ( FileManager.fileExists(unrarApp) ) {
         unpack(filename);
       } else showAlert("Unrar", "Please install Unrar from your Installer");
       return;
    }
    

    url = encodeURI ( "http://"+username+":"+password+"@localhost:8888"+cell.dir+cell.title );
    
     if (Defaults.get(ending)!=null && Defaults.get(ending)!="") {
    
       if (Defaults.get(ending)=="External Safari") {
        log(Defaults.get(ending)+" "+url);
         openURL(url, true);
         return;
       }
    
      if (useFile)
        url = encodeURI ( "file://"+cell.dir+cell.title );

       if (Defaults.get(ending)=="Internal Safari") {
         showWebView(url, false);
         return;
       }
       createMSAppLauncherPList(Defaults.get(ending),filename);
       Application.launchApplicationWithIdentifier(Defaults.get(ending),false);
       
       return;
     }  
    
    if (useFile)
      url = encodeURI ( "file://"+cell.dir+cell.title );

    
    if (ending=="DOC" || ending=="XLS" || ending=="TXT" || ending=="PDF" || ending=="JPG" || ending=="GIF" ||
        ending=="JPEG" || ending=="HTM" || ending=="HTML" || ending=="PNG")
      showWebView(url, false);
    
    
  }
}

table.getSelectedFiles = function() {
  var selected = [];
  for (var i = 0; i< selection.length; i++) 
   if (selection[i]) selected.push(cells[i].dir+cells[i].title);
  return selected;
}

table.onDisclosureClickableForRow = function ( tbl , row )
{
  if (editMode) return true;
  return false;
}

table.onCanDeleteRow = function( tbl , row )
{
  return false;
}

table.onRowDeleted = function( tbl , row )
{
  cells.splice( row , 1 );
}

table.onCanMoveRow = function( tbl , row )
{
  return false;
}


return table;

}

function showWebView(url, showRotated) {

    var done = new UIImageView(Images.imageWithContentsOfFile(Bundle.bundlePath+"/images/button_back.png", true));
    done.position = [280,428];
    done.onTap = function() {
      backToBrowsingMode();
    }
    
    if (showRotated && rotated==false) {
       mainView.setRotationBy(90);  
       mainView.bounds = [0,0,460,320];
       done.position = [420,280];
       rotated=true;
    } 
    if (showRotated==false && rotated) {
       mainView.setRotationBy(-90);  
       mainView.bounds = [0,0,320,460];
       rotated=false;
    }
          
    webView = new WebView(mainView.bounds);
    mainView.transitionFrom( 1, currentView , webView );
    webView.loadURL(url);
    currentView = webView;
    webView.addSubview(done);
        
    viewing = true;
}


function backToBrowsingMode() {
     if (rotated) {
       mainView.setRotationBy(-90);
       mainView.bounds = [0,0,320,460];
       rotated = false;
     }
     showContentOf( currentPath, 2 );
}

function folderUp() {
        if (searchMode) {
          searchMode = false;
        } else {
        currentPath = currentPath.substring(0, currentPath.lastIndexOf('/'));
        currentPath = currentPath.substring(0, currentPath.lastIndexOf('/'))+"/";
        }
        var direction = 2;
        if (restrictAccess && currentPath.indexOf(homeDir)!=0) {
          currentPath = homeDir;
          direction = 0; 
        }
        editMode = false;
        textEditing = false;
        sendEmail = false;
        showContentOf(currentPath, direction);
}


function onAccelerate( x , y , z )
{
   // If shaked
   if (Math.abs(this.xyz[0]) - Math.abs(x) > 0.3 || Math.abs(this.xyz[1]) - Math.abs(y) > 0.3 ){
     if (viewing) backToBrowsingMode(); else folderUp();
   }
   xyz = [x,y,z];

  if (viewing==false) return;
 
  if (lastOrientation != UIHardware.deviceOrientation()){

     if (UIHardware.deviceOrientation()==3 && rotated==false) {
        showWebView(url, true) 
     }
     if (UIHardware.deviceOrientation()==1 && rotated) {
       showWebView(url, false) 
     }
     
     lastOrientation = UIHardware.deviceOrientation();
  }
  
}

function setIcon(cell, fileName) {
  var ending = fileName.substring(fileName.lastIndexOf("."),fileName.length).toUpperCase();
  if (ending==".XLS")
    cell.setImage( excelImage );
  else if (ending==".MP3" || ending==".AIF")
    cell.setImage( mp3Image );
  else if (ending==".MP4" || ending==".M4V" || ending==".3GP")
    cell.setImage( videoImage );
  else if (ending==".PDF")
    cell.setImage( pdfImage );
  else if (ending==".DOC" || ending==".TXT")
    cell.setImage( wordImage );
  else if (ending==".JPG" || ending==".JPEG" || ending==".PNG" || ending==".GIF" || ending==".BMP")
    cell.setImage( imageImage );
  else if (ending==".HTM" || ending==".HTML")
    cell.setImage( htmlImage );
  else if (ending==".ZIP" || ending==".RAR")
    cell.setImage( archiveImage );
  else
    cell.setImage( fileImage );
}



function deleteFiles(clipBoard) {
var as = new UIAlertSheet( "Delete" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Are you sure you want to delete the files?" );

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    as.dismiss( true );
    for (var i=0; i<clipBoard.length; i++) {
      FileManager.remove(clipBoard[i]);    
    }
    editMode = false;
    showContentOf(currentPath, 0);
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}


function showAlert(title,text) {
var as = new UIAlertSheet( title , [ "OK" ] , 1 );
as.setBodyText(title);

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
    as.dismiss( true ); 
  }
as.popupAlertAnimated( true ); 
}
  
function createDirectory() {
var as = new UIAlertSheet( "Create Directory" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Enter name:" );
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "" , "New Directory" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    var result = textField.text;
    if (result!=null && result!="") 
      FileManager.createDirectory(currentPath+result);
    showContentOf(currentPath, 0);
    as.dismiss( true );
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

  
function search() {
var as = new UIAlertSheet( "Search" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Search for files in "+currentPath+": ");
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "" , "Text in Filename" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    as.dismiss( true );
    var result = textField.text;
    if (result!=null && result!="") {
     
      var searchResults = find(currentPath, result, 0);
      searchMode = true;
      showDirectory( searchResults, 3, true );    
    }
    
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

function find(path, findText, depth) {
  findText = findText.toUpperCase();
  if (path.charAt(path.length-1)!="/") path += "/";
  
  var content =  FileManager.directoryContents(path);
  var result = [];
  for (var i=0; i<content.length; i++) {
    var filen = content[i].path.toUpperCase();
    if (filen.indexOf(findText)>-1) {
      content[i].dir = path;
      result.push(content[i]);
    }
    if (content[i].type=="d" && depth<3) {

      var recResults = find(path+content[i].path, findText, depth+1);
      
      for (var j=0; j<recResults.length; j++) result.push(recResults[j]);
    }
  }
  return result;
}

function paste() {
      var command;
      
      if (deleteAfterPaste) command = "/bin/mv "; else command = "/bin/cp ";
      var pb = new UIProgressBar( [10 , 392 , 300 , 48 ] );
      pb.setStyle( 1 );
      currentView.addSubview( pb );
      pb.updateIfNecessary(); 
      var timer = new Timer( 0.05 );
      var stop = true;
      var i = 0;
      var ready = true;
      timer.onTimer = function() {
       if (!ready) return;
        ready=false;
        executeShellCommand(command+"\""+clipboard[i]+"\" \""+currentPath+"\"");     
        pb.setProgress( (i+1)/clipboard.length );
        pb.updateIfNecessary();  
        i++;
        ready=true;
        if (i>=clipboard.length) {timer.stop(); 
          clipboard = [];
          showContentOf(currentPath, 0);
        }
      }
      timer.start();

}

function deleteFiles(clipBoard) {
   var pb = new UIProgressBar( [10 , 392 , 300 , 48 ] );
      pb.setStyle( 1 );
      currentView.addSubview( pb );
      pb.updateIfNecessary(); 
      var timer = new Timer( 0.05 );
      var stop = true;
      var i = 0;
      var ready = true;

      timer.onTimer = function() {
       if (!ready) return;
        ready=false;
        var r = FileManager.remove(clipBoard[i]);   
        
        pb.setProgress( (i+1)/clipBoard.length );
        pb.updateIfNecessary();  
        i++;
        ready=true;
        if (i>=clipBoard.length) {timer.stop(); 
          showContentOf(currentPath, 0);
        }
      }
      timer.start();
}

function unzip(fn, p) {
  executeShellCommand(unzipApp+" \""+fn+"\" -d \""+p+"\"");
}


function unrar(fn, p) {
  if (!FileManager.directoryExists(p)) FileManager.createDirectory(p);
  executeShellCommand(unrarApp+" x -o+ -p- \""+fn+"\" \""+p+"\" --quiet") ;
}


onUnload = function() {
  Defaults.set("lastPath",currentPath);
  Defaults.synchronize();
}


