



function setAssociations(direction) {

  var associationsView = new UIView( mainView.bounds );
  var cells = [ [] , [], [] ];
  
  var topBar = new UINavigationBar( [ 0 , 0 , 320 , 48 ] );
  topBar.showButtonsWithLeftTitle( "Back" , "Add", false );
  topBar.pushNavigationItem( new UINavigationItem( "File Associations" ) );
  topBar.onButtonClicked = 
    function( theBar , theButton )
    {
      if ( theButton == 1 )
      {
    
        var endings = Defaults.get("associations").split(";");
        var cleanEndings = "";
        for (var i=0; i<endings.length; i++) {
          if (Defaults.get(endings[i])==null || Defaults.get(endings[i])=="") 
            Defaults.set(endings[i], null);
          else 
            cleanEndings += endings[i]+";";
        }
        if (cleanEndings.length>1) cleanEndings = cleanEndings.substring(0,cleanEndings.length-1);
        Defaults.set("associations",cleanEndings);
        showContentOf(currentPath, 2);
      } else {
        createAssociation();
      }
    }
  associationsView.addSubview(topBar);
  var endings = Defaults.get("associations").split(";");

  var rect = associationsView.bounds;
  rect[1]+=48;
  rect[3]-=48
  
  var ptable = new UIPreferencesTable( rect );

  ptable.onGetNumberOfGroups = function( tbl )
  {
    return 3;
  }

  ptable.onGetNumberOfRowsInGroup = function( tbl , group )
  {
  switch( group )
  {
    case 0 : return 1;
    case 1 : return cells[1].length;
    case 2 : return 1;
  }
}

// Tell the table that the third group is a label group

ptable.onIsLabelGroup = function( tbl , group )
{
   if (group==0) return true;
   return false;
}

// Now, create the title cells - we only need 2 because the third
// group is a label

var titleCells = [];

ptable.onGetCellForGroup = function( tbl , group )
{
  if ( group >= 0 && group < titleCells.length )
    return titleCells[ group ];
  else
    return null;
};

// Return row heights

ptable.onGetHeightForRow = function( tbl , group , row , proposedHeight )
{
  if ( row == -1 )
  {
    return 5;
  }
  return proposedHeight;
};



var cell;
var control;
var textF;

cell = new UIPreferencesTableCell();
cell.title = "Edit file association and press Enter to save. Delete an association by an empty field.";
cells[ 0 ].push( cell );

for (var i = 0; i<endings.length; i++) {
cell = new UIPreferencesTextTableCell();
cell.title = endings[i];
cell.value =  Defaults.get(endings[i]);
cell.setEnabled( true );
cell.showSelection = false;
textF = cell.textField;
textF.paddingLeft = 30;
textF.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); Defaults.set(cell.title, cell.textField.text); };
if (cell.value!=null || cell.value!="")
  cells[1].push( cell );
}


cell = new UIPreferencesTableCell();
cell.title = "Set to Default";
cell.setUsesBlueDisclosureCircle(true);
cell.onTap = function() {initAssociations(); setAssociations(); }
cells[ 2 ].push( cell );


// Attach the event handler to dole out the cells

ptable.onGetCell = 
  function( tbl , group , row )
  {
    return cells[ group ][ row ];
  };

// And LOAD the table!

ptable.reloadData();

associationsView.addSubview( ptable );
if (direction==null) var direction=1;
mainView.transitionFrom(1, currentView, associationsView);
currentView = associationsView;

}


function createAssociation() {
var as = new UIAlertSheet( "Create Association" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Enter File Ending:" );
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "" , "TXT" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    var result = textField.text.toUpperCase();
    result = result.replace(/;/g, "");
    Defaults.set(result,"");
    var currAss = Defaults.get("associations");
    Defaults.set("associations",currAss+";"+result);
    setAssociations(0);
    as.dismiss( true );
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}


function createMSAppLauncherPList(launchedApplicationId, argument) {
var content = new Data();
content.loadFromString(
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"+
"<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n"+
"<plist version=\"1.0\">\n"+
"<dict>\n"+
  "<key>MSLaunchedAppArguments</key>\n"+
  "<array>\n"+
  "<string>"+argument+"</string>\n"+
  "</array>\n"+
  "<key>MSLaunchedAppIdentifier</key>\n"+
  "<string>"+launchedApplicationId+"</string>\n"+
  "<key>MSLaunchingAppIdentifier</key>\n"+
  "<string>de.bayerstephan.FileBrowser</string>\n"+
"</dict>\n"+
"</plist>" );

if (!FileManager.directoryExists(Application.userLibraryDirectory+"/MobileStudio/"))
   FileManager.createDirectory(Application.userLibraryDirectory+"/MobileStudio/");

content.writeToFile( Application.userLibraryDirectory+"/MobileStudio/"+launchedApplicationId+".plist");

}


function initAssociations() { 
  Defaults.set("TXT","Internal Safari");   
  Defaults.set("HTML","External Safari");  
 
  Defaults.set("MP3","com.system.avplayer");
  Defaults.set("MP4","com.system.avplayer");
  Defaults.set("AIF","com.system.avplayer");
  Defaults.set("M4V","com.system.avplayer");
  Defaults.set("3GP","com.system.avplayer");    
  
  Defaults.set("associations","TXT;HTML;MP3;MP4;AIF;M4V;3GP");
}
