
function deleteFilesDialog(clipBoard) {
var as = new UIAlertSheet( "Delete" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Are you sure you want to delete the files?" );

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    as.dismiss( true );
    deleteFiles(clipBoard);
    editMode = false;
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

function unpack(filename) {
var path = filename.substring(0, filename.lastIndexOf("/")+1);
var ending = filename.substring(filename.lastIndexOf("."),filename.length).toUpperCase();
var unzipDir = filename.substring(filename.lastIndexOf("/")+1,filename.length-4);

var as = new UIAlertSheet( "Extract" , [ "Extract in "+unzipDir+"/" , "Extract here", "Cancel"] , 2 );
as.setBodyText( "" );

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    if (ending==".ZIP") unzip(filename, path+unzipDir);
    if (ending==".RAR") unrar(filename, path+unzipDir);
    
    as.dismiss( true );
    showContentOf(currentPath,0);
  } else
  if (button == 2) {
    if (ending==".ZIP") unzip(filename, path);
    if (ending==".RAR") unrar(filename, path);
    
    as.dismiss( true );
    showContentOf(currentPath,0);
  } 
   as.dismiss( true );
  }
   
  
  as.popupAlertAnimated( true ); 

}


function createNew() {

var as = new UIAlertSheet( "Create" , [ "Create new Folder", "Create new File", "Cancel"] , 2 );
as.setBodyText( "" );

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    as.dismiss( true );
    createDirectory();  
  } else
  if (button == 2) {
    createFile();    
    as.dismiss( true );
  } 
   as.dismiss( true );
  }
   
  
  as.popupAlertAnimated( true ); 

}


function showAlert(title,text) {
var as = new UIAlertSheet( title , [ "OK" ] , 1 );
as.setBodyText(text);

as.setAlertSheetStyle( 2 );
as.onButtonClicked = function( button )
  {
    as.dismiss( true ); 
  }
as.popupAlertAnimated( true ); 
}
  
function createDirectory() {
var as = new UIAlertSheet( "Create Directory" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Enter name:" );
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "" , "New Directory" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    var result = textField.text;
    if (result!=null && result!="") 
      FileManager.createDirectory(currentPath+result);
    showContentOf(currentPath, 0);
    as.dismiss( true );
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

function createFile() {
var as = new UIAlertSheet( "Create File" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Enter name:" );
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "New file.txt" , "New File" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    var f = new Data();
    if (!FileManager.fileExists(currentPath+textField.text))
      f.writeToFile(currentPath+textField.text);
    showContentOf(currentPath, 0);
    as.dismiss( true );
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

  
function search() {
var as = new UIAlertSheet( "Search" , [ "OK" , "Cancel"] , 1 );
as.setBodyText( "Search for files in "+currentPath+": ");
as.setRunsModal(true);
as.setAlertSheetStyle( 2 );
var textField = as.addTextFieldWithValue( "" , "Text in Filename" );
as.onButtonClicked = function( button )
  {
  if ( button == 1 )
  {
    as.dismiss( true );
    var result = textField.text;
    if (result!=null && result!="") {
     
      var searchResults = find(currentPath, result, 0);
      searchMode = true;
      showDirectory( searchResults, 3, true );    
    }
    
  } 
  else {
    as.dismiss( true ); 
  }
   
  }
  as.popupAlertAnimated( true ); 
}

function find(path, findText, depth) {
  findText = findText.toUpperCase();
  if (path.charAt(path.length-1)!="/") path += "/";
  
  var content =  FileManager.directoryContents(path);
  var result = [];
  for (var i=0; i<content.length; i++) {
    var filen = content[i].path.toUpperCase();
    if (filen.indexOf(findText)>-1) {
      content[i].dir = path;
      result.push(content[i]);
    }
    if (content[i].type=="d" && depth<3) {

      var recResults = find(path+content[i].path, findText, depth+1);
      
      for (var j=0; j<recResults.length; j++) result.push(recResults[j]);
    }
  }
  return result;
}

