

function showProps(filename) {

  var propsView = new UIView( mainView.bounds );

  var textF1;
  var textF2;
  var textF3;
  
  var fn = filename.substring(filename.lastIndexOf("/")+1, filename.lastIndexOf("."));
  var ending = filename.substring(filename.lastIndexOf(".")+1, filename.length);
  var permissions = parseInt(FileManager.getAttributes(filename).perm).toString(8);
  var modified = FileManager.getAttributes(filename).modified;
  var size = FileManager.getAttributes(filename).size;
  var type = FileManager.getAttributes(filename).type;
  var path = filename.substring(0, filename.lastIndexOf("/")+1);
  var setRecursivly = false;
  if (type=="d") {
    fn = filename.substring(filename.lastIndexOf("/")+1,filename.length);
  }

  var topBar = new UINavigationBar( [ 0 , 0 , 320 , 48 ] );
  topBar.showButtonsWithLeftTitle( "Save" , "Cancel", false );
  topBar.pushNavigationItem( new UINavigationItem( "File Properties" ) );
  topBar.onButtonClicked = 
    function( theBar , theButton )
    {
      if ( theButton == 1 )
      {
        var rec = "";
        if (setRecursivly) {
          rec = " --recursive ";
        }
        if (textF3.length<=4)
          log(executeShellCommand("/bin/chmod "+rec+textF3.text+" \""+filename+"\"") );

        var newFile = path+textF1.text+"."+textF2.text;
        if (type=="d") newFile = path+textF1.text;
    if (filename!=newFile) {
      FileManager.move(filename, newFile);
      showContentOf(currentPath, 0); 
    }
      } 
      //GO Back
     propMode = false;
     showContentOf(currentPath, 2);
    }
  propsView.addSubview(topBar);

  var rect = propsView.bounds;
  rect[1]+=48;
  rect[3]-=48
  
  var ptable = new UIPreferencesTable( rect );

  ptable.onGetNumberOfGroups = function( tbl )
  {
    return 3;
  }

  ptable.onGetNumberOfRowsInGroup = function( tbl , group )
  {
  switch( group )
  {
    case 0 : if (type=="d") return 1; else return 2;
    case 1 : if (type=="d") return 2; else return 1;
    case 2 : if (type=="d") return 2; else return 3;
  }
}

// Tell the table that the third group is a label group

ptable.onIsLabelGroup = function( tbl , group )
{
   return false;
}

// Now, create the title cells - we only need 2 because the third
// group is a label

var titleCells = [];

var titleCell;

titleCell = new UIPreferencesTableCell();
titleCell.title = "File Name";
titleCells.push( titleCell );

titleCell = new UIPreferencesTableCell();
titleCell.title = "File Permissions";
titleCells.push( titleCell );

titleCell = new UIPreferencesTableCell();
titleCell.title = "Information";

titleCells.push( titleCell );



ptable.onGetCellForGroup = function( tbl , group )
{
  if ( group >= 0 && group < titleCells.length )
    return titleCells[ group ];
  else
    return null;
};

// Return row heights

ptable.onGetHeightForRow = function( tbl , group , row , proposedHeight )
{
  if ( row == -1 )
  {
    return 40;
  }
  return proposedHeight;
};

var cells = [ [] , [] , [] ];

var cell;
var control;

// group 1 , cell 0
cell = new UIPreferencesTextTableCell();
cell.title = "File Name";
cell.value =  fn;
// This also makes it editable
cell.setEnabled( true );
cell.showSelection = false;
textF1 = cell.textField;
textF1.paddingLeft = 30;
textF1.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };

cells[0].push( cell );


cell = new UIPreferencesTextTableCell();
cell.title = "File Ending";
cell.value = ending;
cell.setEnabled( true );
cell.showSelection = false;
textF2 = cell.textField;
textF2.paddingLeft = 30;
textF2.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };

cells[0].push( cell );


cell = new UIPreferencesTextTableCell();
cell.title = "Permissions";
cell.value = permissions;
cell.setEnabled( true );
cell.showSelection = false;
textF3 = cell.textField;
textF3.paddingLeft = 30;
textF3.textTraits.preferredKeyboardType = 2;
textF3.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };

cells[1].push( cell );

cell = new UIPreferencesControlTableCell();
cell.title = "Set recursively";
cell.showSelection = false;
control = new UISwitchControl( [ 210 , 8 , 120 , 30 ] );
control.onValueChanged = function(val) {
  setRecursivly = val;
}
control.on = restrictAccess;
cell.control = control;
if (type=="d")
  cells[1].push( cell );

cell = new UIPreferencesTextTableCell();
cell.title = "File Size";
cell.setEnabled( false );
cell.value = formatSize(size);
cell.showSelection = false;

cells[ 2 ].push( cell );

cell = new UIPreferencesTextTableCell();
cell.title = "Modified";
cell.setEnabled( false );
cell.value = toDate(modified);
cell.showSelection = false;

cells[ 2 ].push( cell );

cell = new UIPreferencesTextTableCell();
cell.title = "Directory";
cell.setEnabled( false );
cell.value = path;
cell.showSelection = false;

cells[ 2 ].push( cell );

// Attach the event handler to dole out the cells

ptable.onGetCell = 
  function( tbl , group , row )
  {
    return cells[ group ][ row ];
  };

// And LOAD the table!

ptable.reloadData();

propsView.addSubview( ptable );
mainView.transitionFrom(1, currentView, propsView);
currentView = propsView;

}


function formatSize(s) {
  var dim = " B";
  if (s>1024) {s /= 1024; dim = " KiB";}
  if (s>1024) {s /= 1024; dim = " MiB";}
  if (s>1024) {s /= 1024; dim = " GiB";}
  s *= 100;
  s = Math.round(s) / 100;
  return s+dim;
}

function toDate(n) {
//  var d = new Date((Number(n) + 978307200)*1000);
  var d = new Date(n); 
  return d.toLocaleString();
}
