
Plugins.load("HttpServer");

var myserver;

function startServer() {
  myServer = new HttpServer(8888);
  myServer.onRequest = onRequest;
  return myServer.localAddress;
 // log ( "Server läuft" );
};

function stopServer() {
  myServer.close();
};

// handle http requests
function onRequest(request) {
  
  var q = request.query;
  var p = request.path;
  var authOK = false;

  
  var authOK = authenticateRequest(request);
      
  // Authorization failed, return 401
  if ( ! authOK ) {
    request.setResponseHeader( "WWW-Authenticate" , 'Basic realm="FileBrowser"' );
    request.replyWithString( 401 , "" );
    return;
  }
  
  request.setResponseHeader( "Server" , "FileBrowser/0.1");
  request.setResponseHeader( "Date" , ( new Date() ).toUTCString() );

  while (p.indexOf("//")>0) {
    p = p.replace("//","/");
  }
  
  
  // Upload?
  if (p.indexOf("action=upload")>0) {
    log(p);
    path = p.substring(0,p.indexOf("action=upload"));
    if (restrictAccess) 
      if (path.indexOf(homeDir)!=0) {
        return;
      }
    
    headers = request.getBodyPartHeaders();
    for (var i=0; i<headers.length; i++) {
      log (headers[i]);
      header = headers[i]["Content-Disposition"];
      
      if (header!=null && header.indexOf("name=\"files\"")>1) {
        filename = header.substring(header.indexOf("filename=")+10, header.length-1);
        request.getBodyPart(i).writeToFile(path+filename);
      }
    }
    p = path;
  } 
  
  // Delete?
   if (p.indexOf("action=delete&")>0) {
    path = p.substring(0,p.indexOf("action=delete&"));
    file = p.substring(p.indexOf("action=delete&")+19,p.length);
    if (restrictAccess) 
      if (file.indexOf(homeDir)!=0 || file==homeDir) {
        return;
      }
      
    FileManager.remove(file);  
    p = path;
  }
  
  
  if(p=="/Folder.png") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/Folder.png", "image/png");
    
  } else if(p=="/File.png") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/File.png", "image/png");

  } else if(p=="/prototype.js") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/prototype.js", "text/javascript");
    
  } else if(p=="/matrixview.js") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/matrixview.js", "text/javascript");
    
  } else if(p=="/files.css") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/files.css", "text/css");

  } else if(p=="/previous.png") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/back.png", "image/png");
    
  } else if(p=="/delete.png") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/delete.png", "image/png");
    
  } else if(p=="/foldernew.png") {
    request.replyWithContentsOfFile(Bundle.bundlePath+"/html/foldernew.png", "image/png");
    
  } else if (FileManager.directoryExists(p)) {
    
     if (restrictAccess) 
      if (p.indexOf(homeDir)!=0) {
        p = homeDir;
      }
      
    if (p.charAt(p.length-1)!="/") p += "/";
   
    var fData = new Data();
    fData.loadFromFile(Bundle.bundlePath+"/html/browser.html");
    var html = fData.asString().split("[[CUSTOM_CONTENT]]");
    var upPath = p.substring(0,p.lastIndexOf("/")-1);
    upPath = upPath.substring(0,upPath.lastIndexOf("/"))+"/";

    fData.loadFromString(html[0] + p + html[1]+p+ html[2] +p+html[3]+ p+ html[4] 
      + upPath+ html[5] + createDirectoryHTML(p) + html[6] );
    
    request.replyWithData(fData, "text/html");
  }
  else {  
    request.replyWithContentsOfFile(p, "application/octet-stream");
  }
  
};


function createDirectoryHTML(path) {
 
 var html = "";
 var fileHtml = "";
 var dir = FileManager.directoryContents(path);

  if (dir != null) {
    for (i = 0; i < dir.length; i++) {
        
        var title = String( dir[i]["path"]);
        
        if (dir[i].type=="d") {
          html += createItem(path, title, "Folder");
        } else {
          fileHtml += createItem(path, title, "File");
        }
    }
  }  
    
  return html + fileHtml;
}

function createItem(path, title, icon) {
showTitle = title;
if (showTitle.length>20)
  showTitle = showTitle.substring(0,20)+" "+showTitle.substring(20,showTitle.length-1);
if (showTitle.length>40)
 showTitle = showTitle.substring(0,39)+"...";
 
return "<li title=\""+encodeURI(path+title)+"\" style=\"text-align: center\">"+
       "<img src=\"/"+icon+".png\" height=\"48\" width=\"48\" />" +
        "<div>"+showTitle+"</div></li>";
}

function authenticateRequest(request) {   
  //log("authenticating:"+request);
  var authInfo = request.getRequestHeader( 'Authorization' );
  var authOk = false;
    
  if ( authInfo != null ){
      var authData = authInfo.split( ' ' );
        
      if( ( authData[ 0 ] == 'Basic' ) && ( authData[ 1 ] != null ) ) {
        var encoded = Base64.decode( authData[ 1 ] ).split( ':' );
        var authUser = encoded[ 0 ];
        var authPassword = encoded[ 1 ];
            
        if( ( authUser == username ) && ( authPassword == password) )
          authOk = true;            
      }         
  }
  return authOk;
};


