


function createSettingsView(parentView, serverUrl) {

  var settingsView = new UIView( parentView.bounds );
  var textField1;
  var textField2;
  var textField3;

  var topBar = new UINavigationBar( [ 0 , 0 , 320 , 48 ] );
  topBar.showButtonsWithLeftTitle( "Back" , "About", false );
  topBar.pushNavigationItem( new UINavigationItem( "Settings" ) );
  topBar.onButtonClicked = 
    function( theBar , theButton )
    {
      if ( theButton == 0 )
      {
        showAlert("About", "FileBrowser\n(c) Stephan Bayer\nwww.bayerstephan.de");
      } else {
        username = textField1.text;
        password = textField2.text;
        if (FileManager.directoryExists(textField3.text))
          homeDir = textField3.text;
        if (homeDir.charAt(homeDir.length-1)!="/") homeDir += "/";
        Defaults.set("username", username);
        Defaults.set("password", password);
        Defaults.set("homeDir", homeDir);
        showContentOf(currentPath, 1);     
      }
    }
  settingsView.addSubview(topBar);

  var rect = settingsView.bounds;
  rect[1]+=48;
  rect[3]-=48
  
  var ptable = new UIPreferencesTable( rect );

  ptable.onGetNumberOfGroups = function( tbl )
  {
    return 5;
  }

  ptable.onGetNumberOfRowsInGroup = function( tbl , group )
  {
  switch( group )
  {
    case 0 : return 1;
    case 1 : return 3;
    case 2 : return 4;
    case 3 : return 1;
    case 4 : return 1;
  }
}

ptable.onIsLabelGroup = function( tbl , group )
{
  switch( group )
  {
    case 0 : return true;
    case 1 : return false;
    case 2 : return false;
    case 3 : return true;
    case 4 : return false;
  }
}

// Now, create the title cells - we only need 2 because the third
// group is a label

var titleCells = [];

var titleCell;

titleCell = new UIPreferencesTableCell();
titleCell.title = "Go to http://"+serverUrl+":8888";
titleCells.push( titleCell );

titleCell = new UIPreferencesTableCell();
titleCell.title = "General Settings";
titleCells.push( titleCell );

titleCell = new UIPreferencesTableCell();
titleCell.title = "Advanced Settings";
titleCells.push( titleCell );

titleCell = new UIPreferencesTableCell();
titleCell.title = "Please Donate!";
titleCells.push( titleCell );

// Add the event handler to return the title cells

ptable.onGetCellForGroup = function( tbl , group )
{
  if ( group >= 0 && group < titleCells.length )
    return titleCells[ group ];
  else
    return null;
};

// Return row heights

ptable.onGetHeightForRow = function( tbl , group , row , proposedHeight )
{
  if (group==4 && row==-1) return 0;
  
  if ( row == -1 )
  {
    return 40;
  }
  return proposedHeight;
};

var cells = [ [] , [] , [], [], [] ];

var cell;
var control;

// group 0 , cell 0
cell = new UIPreferencesTableCell();
cell.title = "on your computer to browse, download, upload and delete (Delete key) files.";

cells[ 0 ].push( cell );

// group 1 , cell 0
cell = new UIPreferencesTextTableCell();
cell.title = "User name";
cell.value = username;
// This also makes it editable
cell.setEnabled( true );
cell.showSelection = false;
// We can alter the attributes of the text field,
// because it is a UITextField
textField1 = cell.textField;
textField1.paddingLeft = 30;
textField1.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };
textField1.onBecomeFirstResponder = function()  { showKeyboard();  };
cells[1].push( cell );

// group 1, cell 1
cell = new UIPreferencesTextTableCell();
cell.title = "Password";
cell.value = password;
// This also makes it editable
cell.setEnabled( true );
cell.showSelection = false;
// We can alter the attributes of the text field,
// because it is a UITextField
textField2 = cell.textField;
textField2.secure = true;
textField2.paddingLeft = 30;
textField2.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };
cells[1].push( cell );

cell = new UIPreferencesTableCell();
cell.title = "Set File Associations";
cell.setUsesBlueDisclosureCircle(true);
cell.onTap = function() {setAssociations(); }
cells[ 1 ].push( cell );

// group 2 , cell 0

cell = new UIPreferencesTextTableCell();
cell.title = "Home Directory";
cell.value = homeDir;
// This also makes it editable
cell.setEnabled( true );
cell.showSelection = false;
// We can alter the attributes of the text field,
// because it is a UITextField
textField3 = cell.textField;
textField3.paddingLeft = 10;
textField3.textColor = [ 0 , 0 , 1 , 1 ];
cell.onReturn = function( cl ) { ptable.setKeyboardVisible( false ); };
cells[2].push( cell );

cell = new UIPreferencesControlTableCell();
cell.title = "Restrict to Home";
cell.showSelection = false;
control = new UISwitchControl( [ 210 , 8 , 120 , 30 ] );
control.onValueChanged = function(val) {
  restrictAccess = val;
  Defaults.set("restrictAccess", (restrictAccess)?"1":"0");
}
control.on = restrictAccess;
cell.control = control;
cells[2].push( cell );

cell = new UIPreferencesControlTableCell();
cell.title = "Show Hidden Files";
cell.showSelection = false;
control = new UISwitchControl( [ 210 , 8 , 120 , 30 ] );
control.onValueChanged = function(val) {
  includeHidden = val;
  Defaults.set("includeHidden",(val)?"1":"0");
}
control.on = includeHidden;
cell.control = control;
cells[2].push( cell );

cell = new UIPreferencesControlTableCell();
cell.title = "Use file://";
cell.showSelection = false;
control = new UISwitchControl( [ 210 , 8 , 120 , 30 ] );
control.onValueChanged = function(val) {
  useFile= val;
  Defaults.set("useFile",(useFile)?"1":"0");
}
control.on = useFile;
cell.control = control;
cells[2].push( cell );


// group 3 , cell 0

cell = new UIPreferencesTableCell();
cell.title = "If you find this application useful, please consider donating a buck or two to support my work on it";
cells[ 3 ].push( cell );

cell = new UIPreferencesTableCell();
cell.title = "Donate";
cell.onTap = function() {openURL("http://www.bayerstephan.de/donate/", false); }
cells[ 4 ].push( cell );

// Attach the event handler to dole out the cells

ptable.onGetCell = 
  function( tbl , group , row )
  {
    return cells[ group ][ row ];
  };

// And LOAD the table!

ptable.reloadData();

settingsView.addSubview( ptable );

return settingsView;

}




function randomString() {
  var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
  var string_length = 8;
  var randomstring = '';
  for (var i=0; i<string_length; i++) {
    var rnum = Math.floor(Math.random() * chars.length);
    randomstring += chars.substring(rnum,rnum+1);
  }
  return randomstring;
}
